<template>
  <popup ref="popup" @close="close">
    <div class="car-panel">
      <div class="content">
        <div class="close-button">
          <close-button @click="() => $refs.popup && $refs.popup.close()" />
        </div>

        <div class="dishes">
          <div class="header">
            <h1 class="header-title">{{ $t("preorderCartPanel.title") }}</h1>
          </div>

          <div class="section">
            <h2 class="section-title">
              {{ $t(`${cartPanelScope}.restaurant`) }}
            </h2>
            <div class="section-body mb-2">
              <div class="restaurant section-content row">
                <div class="restaurant-photo col" :style="photoStyle"></div>
                <div class="restaurant-info col">
                  <div class="restaurant-name">
                    {{ restaurant.company.name }}
                  </div>
                  <div class="restaurant-address">
                    {{ restaurant.buildingAddress }}
                  </div>
                </div>
              </div>
            </div>
            <h2 class="section-title">
              {{ $t(`${cartPanelScope}.pickupTime`) }}
            </h2>
            <div class="section-body mb-2">
              <div
                class="prepare section-content row"
                @click="toggleTimeSelector"
                :class="{ opened: timeSelectorOpened }"
              >
                <cart-panel-time-selector
                  v-if="timeSelectorOpened"
                  @close="closeTimeSelector"
                  @dateChanged="date => $emit('dateChanged', date)"
                  @timeChanged="time => $emit('timeChanged', time)"
                  :times="times"
                  :time="time"
                  :dates="dates"
                  :date="date"
                  :scopeCartPanel="cartPanelScope"
                />
                <div class="prepare-time col">
                  <span class="prepare-time-label"
                    >{{ formatedDate }} {{ time }}</span
                  >
                  <span class="ic-sm-arrow"></span>
                </div>
              </div>
            </div>
          </div>

          <div class="section desc-section">
            <div class="section-body">
              <remind class="mb-1" />
              {{ $t(`${cartPanelScope}.desc`) }}
            </div>
          </div>

          <div class="section">
            <h2 class="section-title">
              {{ $t("preorderCartPanel.yourOrder") }}
            </h2>
            <div class="section-body">
              <div
                v-for="(item, key) in data"
                class="dish section-content"
                :key="key"
              >
                <cart-panel-dish
                  :data="item"
                  @updateCount="updateItemCount"
                  @remove="$emit('remove', item)"
                />
              </div>
              <div class="total section-content row">
                <div class="total-label col">
                  {{ $t("preorderCartPanel.amount") }}
                </div>
                <div class="total-price col"><price :price="totalPrice" /></div>
              </div>
              <div class="total section-content row" v-if="isDelivery">
                <div class="total-label col">
                  {{ $t(`${cartPanelScope}.charge`) }}
                </div>
                <div class="total-price col">
                  <price :price="restaurant.groupMeta.deliveryFee" />
                </div>
              </div>
              <div class="total section-content row" v-if="isDelivery">
                <div class="total-label col">
                  {{ $t(`preorderCartPanel.total`) }}
                </div>
                <div class="total-price col">
                  <price
                    :price="totalPrice + restaurant.groupMeta.deliveryFee"
                  />
                </div>
              </div>
            </div>
          </div>

          <div class="section">
            <h2 class="section-title">{{ $t("preorderCartPanel.note") }}</h2>
            <div class="note-wrapper">
              <textarea
                class="note"
                :placeholder="$t('preorderCartPanel.notePlaceholder')"
                @change="e => $emit('updateNote', e.target.value)"
                v-model="note"
              />
            </div>
          </div>
        </div>

        <button class="submit" :disabled="!count || submitted" @click="submit">
          {{ $t("preorderCartPanel.submit") }}
        </button>
      </div>
    </div>
  </popup>
</template>

<script>
import moment from "moment";
import Popup from "../../Popup";
import Price from "@/components/Price";
import Remind from "@/components/Remind";
import CartPanelDish from "./CartPanelDish";
import CloseButton from "@/components/CloseButton";
import * as groupPresenter from "@/presenters/group";
import CartPanelTimeSelector from "./CartPanelTimeSelector";

export default {
  props: {
    restaurant: {
      type: Object,
      required: true
    },
    note: {
      type: String
    },
    data: {
      type: Array
    },
    time: {
      type: String,
      required: true
    },
    times: {
      type: Array,
      required: true
    },
    date: {
      type: Date,
      required: true
    },
    dates: {
      type: Array,
      required: true
    }
  },

  components: {
    Popup,
    Price,
    Remind,
    CloseButton,
    CartPanelDish,
    CartPanelTimeSelector
  },

  data() {
    return {
      timeSelectorOpened: false,
      submitted: false
    };
  },

  computed: {
    photoStyle() {
      const company = this.restaurant.company;
      return {
        "background-image": `url('${this.restaurant.logo}')`,
        "background-color": `${company.webBannerBackgroundColor}`,
        "border-color": `${company.webBannerBackgroundColor}`
      };
    },

    count() {
      return this.data.reduce((total, item) => total + item.count, 0);
    },

    totalPrice() {
      return this.data.reduce((total, item) => total + item.price, 0);
    },

    formatedDate() {
      return groupPresenter.formatDate(this.date);
    },

    isPreorder() {
      return this.$route.name === "RestaurantPreorder";
    },

    isDelivery() {
      return this.$route.name === "RestaurantDelivery";
    },

    cartPanelScope() {
      return this.isPreorder
        ? "preorderCartPanel"
        : this.isDelivery
        ? "deliveryCartPanel"
        : "";
    }
  },

  methods: {
    close() {
      this.$emit("close");
    },

    toggleTimeSelector() {
      this.timeSelectorOpened = !this.timeSelectorOpened;
    },

    closeTimeSelector() {
      this.timeSelectorOpened = false;
    },

    updateItemCount(item) {
      this.$emit("updateItemCount", item);
    },

    submit() {
      this.submitted = true;
      this.$emit("createOrder");
      this.trackSubmit();
    },

    trackPageView() {
      const content = this.data
        .map(item => item.dish.name + " " + item.price)
        .join(" && ");
      window.gtag("event", "pageview", {
        event_category: "美食地圖預定外帶購物車",
        event_label: JSON.stringify({
          category: this.restaurant.buildingAddress,
          value: this.restaurant.company.name,
          content: content,
          total: this.totalPrice
        })
      });
    },

    trackSubmit() {
      window.gtag("event", "Submit shopping cart", {
        event_label: JSON.stringify({ ...this.restaurant.dataForMixpanel })
      });
    }
  },

  mounted() {
    this.trackPageView();
  }
};
</script>

<style lang="scss" scoped>
.car-panel {
  position: relative;
  left: 0;
  top: 0;
  width: 100%;
  height: 100%;
  margin: 0 auto;
  user-select: none;
  text-align: center;
  box-sizing: border-box;

  @include media-breakpoint-up(md) {
    &::after {
      content: "";
      display: inline-block;
      height: 100%;
      width: 0;
      vertical-align: middle;
    }
  }
}

.content {
  display: flex;
  flex-direction: column;
  position: absolute;
  left: 0;
  top: 0;
  right: 0;
  bottom: 0;
  background: $color-white;
  box-shadow: 0 5px 10px rgba(0, 0, 0, 0.2);
  box-sizing: border-box;
  overflow: hidden;
  text-align: left;

  @include media-breakpoint-up(md) {
    display: inline-flex;
    width: 540px;
    position: relative;
    vertical-align: middle;
    max-height: 90vh;
  }
}

.dishes {
  overflow-y: scroll;
}

.row {
  display: flex;
  margin: 0;
}

.col {
  flex: 1;
}

.close-button {
  position: absolute;
  z-index: 1;
  top: 10px;
  right: 10px;
  width: 32px;
  height: 32px;
  vertical-align: middle;

  @include media-breakpoint-up(md) {
    top: 20px;
    right: 20px;
  }
}

.header {
  position: relative;
  overflow: hidden;

  &::after {
    content: "";
    position: absolute;
    left: 50%;
    bottom: 0;
    width: 68px;
    height: 2px;
    margin-left: -34px;
    background: $color-sky-grey;
  }
}

.header-title {
  text-align: center;
  font-size: 24px;
  font-weight: 500;
  margin: 20px 0;
}

.section {
  margin-top: 20px;
}

.section-title {
  font-size: 14px;
  margin: 0 30px 10px;
  font-weight: normal;
  line-height: 14px;
}

.section-body {
  border: 1px $color-silver-grey solid;
  margin: 0 20px;
  border-radius: 4px;
  box-sizing: border-box;
}

.desc-section {
  color: $color-primary-grey;
  font-size: 12px;

  .section-body {
    border: none;
    margin: 0 30px;
  }
}

.section-content {
  padding: 0 20px;
  border-bottom: 1px $color-silver-grey solid;

  &:last-child {
    border: none;
  }
}

.restaurant {
  padding-top: 20px;
  padding-bottom: 20px;
}

.restaurant-photo {
  display: inline-block;
  width: 52px;
  height: 52px;
  background-position: center center;
  background-size: contain;
  background-repeat: no-repeat;
  border: 5px rgba(0, 0, 0, 0) solid;
  flex: 0 0 52px;
  margin-right: 20px;
}

.restaurant-name {
  font-size: 18px;
  font-weight: 500;
  line-height: 1.78em;
}

.restaurant-address {
  font-size: 13px;
  color: $color-primary-grey;
}

.prepare {
  position: relative;
  padding-top: 10px;
  padding-bottom: 10px;
  font-size: 14px;

  &:active,
  &.opened {
    background: $color-genesis-white;
  }
}

.prepare-time {
  text-align: left;
  position: relative;
  padding: 0;
  cursor: pointer;

  .ic-sm-arrow {
    font-size: 12px;
    position: absolute;
    right: 0;
    top: 50%;
    margin-top: -6px;
    line-height: 1;
    vertical-align: middle;

    &:before {
      line-height: 1;
      vertical-align: middle;
    }
  }

  .prepare-time-label {
    display: inline-block;
    line-height: 1;
    vertical-align: middle;
  }
}

.opened .prepare-time .ic-sm-arrow {
  transform: rotateZ(180deg);
}

.dish {
  padding-top: 10px;
  padding-bottom: 10px;
}

.total {
  font-size: 14px;
  padding-top: 10px;
  padding-bottom: 10px;
}

.total-price {
  text-align: right;
}

.note-wrapper {
  margin: 0 30px 40px;

  @include media-breakpoint-up(md) {
    margin-bottom: 26px;
  }
}

.note {
  padding: 10px 15px;
  width: 100%;
  height: 109px;
  border: 1px $color-silver-grey solid;
  border-radius: 2px;
  box-sizing: border-box;
  resize: none;

  &::placeholder {
    color: $color-silver-grey;
  }
}

.submit {
  flex-grow: 0;
  flex-shrink: 0;
  height: 48px;
  width: 100%;
  border: none;
  background: $color-skm-red;
  color: $color-white;
  padding: 0;
  margin: 0;
  line-height: 48px;
  font-size: 16px;
  font-weight: 500;
  cursor: pointer;

  &:disabled {
    background: $color-silver-grey;
    cursor: default;
  }
}
</style>
